
package de.ivu.elect.business.staat.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.staat.entity.StaatenGruppe;

@RequestScoped
@Named(StaatenGruppeConversationSelect.COMPONENT_NAME)
public class StaatenGruppeConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatenGruppeConversationSelect";

  @Inject
  protected transient StaatenGruppeExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(StaatenGruppeConversationStore.class)
  protected transient StaatenGruppeConversationStore conversationStore;

  public StaatenGruppeConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public StaatenGruppe getEntity() {
    return getEntityInternal();
  }

  private StaatenGruppe getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(StaatenGruppe entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.staat.entity.StaatenGruppePK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(StaatenGruppe entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.staat.entity.StaatenGruppePK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.staat.entity.StaatenGruppePK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected StaatenGruppe attach(StaatenGruppe entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected StaatenGruppe attach( de.ivu.elect.business.staat.entity.StaatenGruppePK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
